U.Managers = (function() {
    var obj = {};
    var repo = Lib.createRepo();

    function GameplayManager() {

        var bonusIfScore = false;
        var bonusType = "";
        var bonusVal = 0;

        this.ballLaunched = function() {
            if (Lib.check.exists(U.GLOB.FACTORY.guiManager.mainGameGui)) {
                U.STATS.availableBalls -= 1;
                p("####### SUBSTRACTING A BALL");
                U.GLOB.FACTORY.guiManager.mainGameGui.substractBalls(1);
                if (U.STATS.availableBalls < 0) {
                    U.STATS.availableBalls = 0;
                    p("TRIGGERING GAME OVER");
                }
            }
        }

        this.ballEnteredHoop = function() {

            U.GLOB.FACTORY.music.ballEnteredHoop.play();



            if (Lib.check.exists(U.GLOB.FACTORY.guiManager.mainGameGui)) {

                //ADDING BALLS
                if (U.STATS.availableBalls < 10) {



                    //Add 1 ball. If bonuses availabel add more
                    var ballNum = 1;
                    if (U.STATS.currentComboChain === 2 || U.STATS.currentComboChain === 4) {
                        ballNum = 2;
                    }
                    else if (U.STATS.currentComboChain === 6 || U.STATS.currentComboChain === 8 || U.STATS.currentComboChain === 10) {
                        ballNum = 3;
                    }
                    else if (U.STATICS.currentComboChain >= 11) {
                        ballNum = 3;
                    }
                    // else if(U.STATICS.currentComboChain >=15){
                    //     ballNum = 4;
                    // }

                    U.STATS.availableBalls += ballNum;
                    if (U.STATS.availableBalls > U.STATS.maxBalls) {
                        U.STATS.availableBalls = U.STATS.maxBalls;
                    }

                    U.GLOB.FACTORY.guiManager.mainGameGui.addBalls(ballNum);
                }


                //MANAGING COMBO CHAINS
                if (U.STATICS.ballWasLaunchedCounter === 1) {
                    U.STATICS.ballWasLaunchedCounter = 0;
                    p("INCREASE COMBO CHAIN");
                    U.STATS.currentComboChain += 1;
                    U.GLOB.FACTORY.guiManager.mainGameGui.showCombo(U.STATS.currentComboChain);
                }

                //AWARDING POINTS
                var score = U.STATICS.getBaseScore() * U.STATICS.getScoreMultiplier(U.STATS.currentComboChain - 1);
                U.STATS.currentScore += score;
                U.GLOB.FACTORY.guiManager.mainGameGui.addScore(score);

                //SHow score multiplier
                U.GLOB.FACTORY.guiManager.mainGameGui.showScoreMultiplier(U.STATS.currentComboChain);

                //Award bonuses
                _awardBonus();
                U.GLOB.FACTORY.guiManager.mainGameGui.hideBonusIndicator();

                //increasing scored balls
                U.STATICS.totalEnteredHoopBalls += 1;
                //set round max combo chain
                if (U.STATS.currentComboChain > U.STATICS.roundMaxComboChain) {
                    U.STATICS.roundMaxComboChain = U.STATS.currentComboChain;
                }
            }

        }

        function _awardBonus() {
            if (bonusIfScore) {
                bonusIfScore = false;

                if (bonusType === "maxTrajectory") {
                    p("Awarding Max Traj bonus ");
                    U.STATS.bonusCountMaxTraj += bonusVal;
                    U.GLOB.FACTORY.guiManager.mainGameGui.setValMaxTrajectory(U.STATS.bonusCountMaxTraj);
                    bonusVal = 0;
                    U.GLOB.FACTORY.music.bonusGain.play();
                }
                else if (bonusType === "ghostObstacles") {
                    p("awarding ghost obstacles bonus");
                    p("Before value of bonus count ghost obstacle " + U.STATS.bonusCountGhostObstacles);
                    p("Val Value " + bonusVal);
                    U.STATS.bonusCountGhostObstacles += bonusVal;
                    U.GLOB.FACTORY.guiManager.mainGameGui.setValGhostObstacles(U.STATS.bonusCountGhostObstacles);
                    bonusVal = 0;
                    p("Bonus count ghost obstacle " + U.STATS.bonusCountGhostObstacles);
                    U.GLOB.FACTORY.music.bonusGain.play();
                }
            }
        }

        function _manageBonuses() {

            var chanceMaxTraj = 0;
            var isBonusMaxTraj = false;

            var chanceGhostObstacles = 0;
            var isBonusGhostObstacles = false;
            //Hide bonus indicator if ball was launched
            if (U.STATICS.ballWasLaunchedBonus) {
                U.STATICS.ballWasLaunchedBonus = false;
                // U.GLOB.FACTORY.guiManager.mainGameGui.hideBonusIndicator();

                //SUBSTRACT FROM BONUSES
                U.STATS.bonusCountMaxTraj -= 1;
                if (U.STATS.bonusCountMaxTraj < 0) {
                    U.STATS.bonusCountMaxTraj = 0;
                }
                U.STATS.bonusCountGhostObstacles -= 1;
                if (U.STATS.bonusCountGhostObstacles < 0) {
                    U.STATS.bonusCountGhostObstacles = 0;
                }

            }


            if (U.STATICS.ballCreatedBonus) {
                U.STATICS.ballCreatedBonus = false;

                //manage shadow obstacles flag
                if (U.STATS.bonusCountGhostObstacles > 0) {
                    U.STATICS.shadowObstacleEnabled = true;
                }
                else {
                    U.STATICS.shadowObstacleEnabled = false;
                }

                bonusIfScore = false;
                bonusType = "";
                bonusVal = 0;


                U.GLOB.FACTORY.guiManager.mainGameGui.hideBonusIndicator();

                //See what chances bonuses have
                chanceMaxTraj = _getBonusChanceMaxTraj();
                isBonusMaxTraj = Lib.UTILS.happens(chanceMaxTraj);

                chanceGhostObstacles = _getBonusChanceGhostObstacles();
                isBonusGhostObstacles = Lib.UTILS.happens(chanceGhostObstacles);

                //decide between one of the two bonuses
                if (isBonusMaxTraj && isBonusGhostObstacles) {
                    //both true, pick one
                    if (Lib.UTILS.happens(0.5)) {
                        bonusType = "maxTrajectory";
                    }
                    else {
                        bonusType = "ghostObstacles";
                    }
                    bonusIfScore = true;
                    bonusVal = _getBonusValMaxTraj();
                    U.GLOB.FACTORY.guiManager.mainGameGui.showBonusIndicator();

                }
                else if (isBonusMaxTraj) {
                    bonusType = "maxTrajectory";
                    bonusIfScore = true;
                    bonusVal = _getBonusValMaxTraj();
                    U.GLOB.FACTORY.guiManager.mainGameGui.showBonusIndicator();
                }
                else if (isBonusGhostObstacles) {
                    bonusType = "ghostObstacles";
                    bonusIfScore = true;
                    bonusVal = _getBonusValMaxTraj();
                    U.GLOB.FACTORY.guiManager.mainGameGui.showBonusIndicator();
                }

                p("Chance of bonus for max traj " + (chanceMaxTraj * 100).toString() + "% and bonus is " + isBonusMaxTraj + " and val is " + bonusVal);
                p("chance of bonus for ghost obst " + (chanceGhostObstacles * 100).toString() + "% and bonus is " + isBonusGhostObstacles + " and val is " + bonusVal);

                //SET VALUES FOR BONUSES GUI
                U.GLOB.FACTORY.guiManager.mainGameGui.setValMaxTrajectory(U.STATS.bonusCountMaxTraj);
                U.GLOB.FACTORY.guiManager.mainGameGui.setValGhostObstacles(U.STATS.bonusCountGhostObstacles);
            }

        }

        function _getBonusChanceMaxTraj() {
            var chance = 0;
            if (U.STATICS.totalCreatedBalls > 5) {

                if (U.STATS.diff === U.STATS.diffType.MEDIUM) {
                    chance = Lib.UTILS.randFloat(0.1, 0.25);
                }
                else if (U.STATS.diff === U.STATS.diffType.HARD) {
                    chance = Lib.UTILS.randFloat(0.1, 0.35);
                }
                else if (U.STATS.diff === U.STATS.diffType.VERY_HARD) {
                    chance = Lib.UTILS.randFloat(0.1, 0.4);
                }
            }


            //if there is a bonus already make the chance smaller
            if (chance >= 0.1) {
                if (U.STATS.bonusCountMaxTraj >= 1 && U.STATS.bonusCountMaxTraj < 3) {
                    chance = chance;
                }
                else if (U.STATS.bonusCountMaxTraj >= 3 && U.STATS.bonusCountMaxTraj < 6) {
                    chance = 0.1;
                }
                else if (U.STATS.bonusCountMaxTraj >= 6) {
                    chance = 0.05;
                }

                //if there's already a bonus have a chance of being 0
                if (U.STATS.bonusCountMaxTraj >= 1) {
                    if (Lib.UTILS.happens(0.9)) {
                        chance = 0;
                    }
                }
            }


            return chance;
        }

        function _getBonusChanceGhostObstacles() {
            var chance = 0;
            if (U.STATICS.totalCreatedBalls > 5) {

                if (U.STATS.diff === U.STATS.diffType.MEDIUM) {
                    chance = Lib.UTILS.randFloat(0.1, 0.25);
                }
                else if (U.STATS.diff === U.STATS.diffType.HARD) {
                    chance = Lib.UTILS.randFloat(0.1, 0.35);
                }
                else if (U.STATS.diff === U.STATS.diffType.VERY_HARD) {
                    chance = Lib.UTILS.randFloat(0.1, 0.4);
                }
            }


            //if there is a bonus already make the chance smaller
            if (chance >= 0.1) {
                if (U.STATS.bonusCountGhostObstacles >= 1 && U.STATS.bonusCountGhostObstacles < 3) {
                    chance = chance;
                }
                else if (U.STATS.bonusCountGhostObstacles >= 3 && U.STATS.bonusCountGhostObstacles < 6) {
                    chance = 0.1;
                }
                else if (U.STATS.bonusCountGhostObstacles >= 6) {
                    chance = 0.05;
                }

                //if there's already a bonus have a chance of being 0
                if (U.STATS.bonusCountGhostObstacles >= 1) {
                    if (Lib.UTILS.happens(0.9)) {
                        chance = 0;
                    }
                }
            }


            return chance;
        }


        function _getBonusValMaxTraj() {
            var val = 2;
            if (Lib.UTILS.happens(0.5)) {
                val = 2;
            }
            else if (Lib.UTILS.happens(0.25)) {
                val = 3;
            }

            else if (Lib.UTILS.happens(0.1)) {
                val = 5;
            }
            return val;
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    repo.removeObj(self);
                    self.destroyWasCalled = true;
                }
            }
            //OPTIONAL--------------------

        this._update = function() {

            if (U.STATICS.ballWasLaunchedCounter > 1) {
                U.STATICS.ballWasLaunchedCounter = 1;
                U.STATS.currentComboChain = 0;
                U.GLOB.FACTORY.guiManager.mainGameGui.showScoreMultiplier(U.STATS.currentComboChain);
                p("RESETING COMBO CHAIN");
            }

            _manageBonuses();

        }
    }
    obj.GameplayManager = GameplayManager;

    function StateManager() {
        var self = this;

        this.context = self;
        this.state = U.STATICS.stateType.MENU;

        var pauseGuiEvent = undefined;

        this.playClickedFromMenu = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            p("SM Play From Menu");
            self._hideMainMenuGui(0.2);
            self._showGameplayGui(0.9);
            U.LocalFx.transitionScreen();
            //disable self and neighbor buttons
            U.GLOB.BUTTONS.playFromMenu.enabled = false;
            U.GLOB.BUTTONS.soundFromMenu.enabled = false;
            //game changing
            U.STATS.resetToStartValues();
            U.STATICS.resetToStartValues();
            U.GLOB.FACTORY.levelAndBallCreator.clearLevel();
            U.GLOB.FACTORY.guiManager.mainGameGui.setAbsBallsVal(U.STATS.availableBalls);
            self._createLevelDelayed(2.2);

            // U.Platform.analytics();
            // U.Platform.serveAds(game);
            U.Platform.prepareAds();
        }

        this.soundClickedFromMenu = function() {
            p(" SM sound  toggle from menu");
            U.GLOB.FACTORY.music.mute(!U.GLOB.BUTTONS.soundFromMenu.toggleVal);
            U.GLOB.FACTORY.music.buttonClick.play();
            p(U.GLOB.BUTTONS.soundFromMenu);
        }

        this.creditsClickedFromMenu = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            p("SM credits button");
            self._showCreditsGui();
        }

        this.playClickedFromGameOver = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            U.Platform.serveAds(game, doStuff, this);

            function doStuff() {
                p("SM play clicked from game over");
                self._hideEndGameGui(0.2);
                self._showGameplayGui(0.9);
                U.LocalFx.transitionScreen();

                U.GLOB.BUTTONS.playFromEndGame.enabled = false;
                U.GLOB.BUTTONS.menuFromEndGame.enabled = false;

                //game changing
                U.STATS.resetToStartValues();
                U.STATICS.resetToStartValues();
                U.GLOB.FACTORY.levelAndBallCreator.clearLevel();
                U.GLOB.FACTORY.guiManager.mainGameGui.setAbsBallsVal(U.STATS.availableBalls);
                self._createLevelDelayed(2.2);
            }

        }
        this.menuClickedFromGameOver = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            U.Platform.serveAds(game, doStuff, this);

            function doStuff() {
                self._hideEndGameGui(0.3);
                self._showMainMenuGui(0.8);
                U.LocalFx.transitionScreen();
                p("SM menu from game over");
                U.GLOB.BUTTONS.menuFromEndGame.enabled = false;
                U.GLOB.BUTTONS.playFromEndGame.enabled = false;


                U.GLOB.FACTORY.levelAndBallCreator.clearLevel();
            }
        }
        this.pauseClickedFromMainGame = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            p("SM Pause clicked from main game");
            self._showPauseGui();
            U.GLOB.BUTTONS.pauseFromGameplay.enabled = false;
            game.paused = true;
            U.STATICS.ignoreLaunchBall = true;

            //GAME CHANGING
        }


        this.pauseHandleClicks = function(event) {

            if (!(self.state === U.STATICS.stateType.PAUSE)) {
                return;
            }

            if (Lib.check.exists(U.GLOB.BUTTONS.resumeFromPause) && U.GLOB.OTHER.resumeButtonRect.contains(event.x, event.y)) {
                p("RESUME");
                game.paused = false;
                self.resumeClickedFromPause();
            }

            if (Lib.check.exists(U.GLOB.BUTTONS.menuFromPause) && U.GLOB.OTHER.menuButtonRect.contains(event.x, event.y)) {
                p("RESUME");
                game.paused = false;
                self.menuClickedFromPause();
            }

        }

        //pause event
        pauseGuiEvent = game.input.onDown.add(self.pauseHandleClicks, self);

        this.resumeClickedFromPause = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            p("SM Resume clicked from pause");
            self._hidePauseGui();
            // U.GLOB.BUTTONS.pauseFromGameplay.enabled =true;
            U.GLOB.BUTTONS.resumeFromPause.enabled = false;
            U.GLOB.BUTTONS.menuFromPause.enabled = false;


            //GAME CHANGING
            game.paused = false;
            self.state = U.STATICS.stateType.PLAY;
        }

        this.menuClickedFromPause = function() {
            U.GLOB.FACTORY.music.buttonClick.play();
            p("SM resume clicked from pause");
            self._hidePauseGui();
            self._hideGameplayGui(0);
            self._showMainMenuGui(0.7);
            U.LocalFx.transitionScreen();
            U.GLOB.BUTTONS.menuFromPause.enabled = false;
            U.GLOB.BUTTONS.resumeFromPause.enabled = false;

            U.GLOB.FACTORY.levelAndBallCreator.clearLevel();
        }

        this.triggerGameOver = function() {
            self.state = U.STATICS.stateType.GAME_OVER;

            U.GLOB.FACTORY.levelAndBallCreator.clearLevel();
            U.GeneralStore.setHighScore(U.STATS.currentScore);

            self._hideGameplayGui(0);
            self._showEndGameGui(1.5);

            U.GLOB.BUTTONS.pauseFromGameplay.enabled = false;

        }

        //private --- 

        var _mainGameGuiEvent = undefined;
        var _gameplayGuiEvent = undefined;
        var _endGameGuiEvent = undefined;
        var _createLevelEvent = undefined;

        this._showMainMenuGui = function(seconds = 0.5) {

            self.state = U.STATICS.stateType.MENU;

            function _eventFunc() {
                U.GLOB.FACTORY.guiManager.menuGui.showGui();
                U.GLOB.FACTORY.guiManager.menuGui.showVignette();
                U.GLOB.FACTORY.guiManager.menuGui.showBlurredTrees();
                U.GLOB.FACTORY.guiManager.menuGui.showBall();

                U.GLOB.BUTTONS.playFromMenu.enabled = true;
                U.GLOB.BUTTONS.soundFromMenu.enabled = true;
            }

            if (Lib.check.exists(_mainGameGuiEvent)) {
                game.time.events.remove(_mainGameGuiEvent);
            }

            _mainGameGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._hideMainMenuGui = function(seconds = 0.5) {

            function _eventFunc() {
                U.GLOB.FACTORY.guiManager.menuGui.hideGui();
                U.GLOB.FACTORY.guiManager.menuGui.hideVignette();
                U.GLOB.FACTORY.guiManager.menuGui.hideBlurredTrees();
                U.GLOB.FACTORY.guiManager.menuGui.hideBall();
            }

            if (Lib.check.exists(_mainGameGuiEvent)) {
                game.time.events.remove(_mainGameGuiEvent);
            }

            _mainGameGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._showGameplayGui = function(seconds = 0.5) {
            self.state = U.STATICS.stateType.PLAY;

            function _eventFunc() {
                U.GLOB.FACTORY.basketballSetup.hoop.show(0.5);
                U.GLOB.FACTORY.guiManager.mainGameGui.showGui();

                U.GLOB.BUTTONS.pauseFromGameplay.enabled = true;

            }

            if (Lib.check.exists(_gameplayGuiEvent)) {
                game.time.events.remove(_gameplayGuiEvent);
            }

            _gameplayGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._createLevelDelayed = function(seconds = 1) {
            function _eventFunc() {
                U.GLOB.FACTORY.levelAndBallCreator.makeBallAndLevel();

            }

            if (Lib.check.exists(_createLevelEvent)) {
                game.time.events.remove(_createLevelEvent);
            }

            _createLevelEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._hideGameplayGui = function(seconds = 0.5) {
            function _eventFunc() {
                U.GLOB.FACTORY.basketballSetup.hoop.hide(0.5);
                U.GLOB.FACTORY.guiManager.mainGameGui.hideGui();
            }

            if (Lib.check.exists(_gameplayGuiEvent)) {
                game.time.events.remove(_gameplayGuiEvent);
            }

            _gameplayGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._showEndGameGui = function(seconds = 0.5) {

            self.state = U.STATICS.stateType.GAME_OVER;


            function _eventFunc() {
                U.GLOB.FACTORY.guiManager.endGameGui.showGui();
                U.GLOB.FACTORY.guiManager.menuGui.showVignette();
                U.GLOB.FACTORY.guiManager.menuGui.showBlurredTrees();

                U.GLOB.BUTTONS.playFromEndGame.enabled = true;
                U.GLOB.BUTTONS.menuFromEndGame.enabled = true;
            }
            if (Lib.check.exists(_endGameGuiEvent)) {
                game.time.events.remove(_endGameGuiEvent);
            }

            _endGameGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._hideEndGameGui = function(seconds = 0.5) {
            function _eventFunc() {
                U.GLOB.FACTORY.guiManager.endGameGui.hideGui();
                U.GLOB.FACTORY.guiManager.menuGui.hideVignette();
                U.GLOB.FACTORY.guiManager.menuGui.hideBlurredTrees(0.6);
            }
            if (Lib.check.exists(_endGameGuiEvent)) {
                game.time.events.remove(_endGameGuiEvent);
            }

            _endGameGuiEvent = game.time.events.add(Phaser.Timer.SECOND * seconds, _eventFunc, this);
        }

        this._showPauseGui = function() {
            self.state = U.STATICS.stateType.PAUSE;
            U.GLOB.FACTORY.guiManager.pauseGui.showGui();
            U.GLOB.BUTTONS.resumeFromPause.enabled = true;
            U.GLOB.BUTTONS.menuFromPause.enabled = true;
        }

        this._hidePauseGui = function() {
            U.GLOB.FACTORY.guiManager.pauseGui.hideGui();
            U.GLOB.BUTTONS.pauseFromGameplay.enabled = true;
        }

        this._showCreditsGui = function() {
            U.GLOB.FACTORY.guiManager.creditsGui.showGui();
        }

        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    repo.removeObj(self);
                    self.destroyWasCalled = true;
                }
            }
            //OPTIONAL--------------------

        this._update = function() {

            // if (U.STATICS.ballWasLaunchedCounter > 1) {
            //     U.STATICS.ballWasLaunchedCounter = 1;
            //     U.STATS.currentComboChain = 0;
            //     U.GLOB.FACTORY.guiManager.mainGameGui.showScoreMultiplier(U.STATS.currentComboChain);
            //     p("RESETING COMBO CHAIN");
            // }

            // _manageBonuses();

            // if( U.STATS.availableBalls<=0 &&  U.STATICS.ballWasLaunchedGameOver){
            //     U.STATICS.ballWasLaunchedGameOver = false;
            //     p("If doesnt enter trigger game over################");
            // }

        }




        //FINISHING CALLS
        // this._showMainMenuGui(0.7);
        // _showGameplayGui(0.5);
        // _showEndGameGui(0.2);
        this._showMainMenuGui(1);
        // this._showEndGameGui(0.7);



    }

    obj.StateManager = StateManager;



    function Scene() {
        var groups = U.GLOB.GROUPS;
        var self = this;

        var sky = Lib.UTILS.createImageInGroup(0, 0, "sky", groups.sky);
        var mountain = Lib.UTILS.createImageInGroup(170, 150, "mountain", groups.mountain);
        var staticTrees = Lib.UTILS.createImageInGroup(0, 200, "staticTrees", groups.staticTrees);
        var grass = Lib.UTILS.createImageInGroup(0, 266, "grass", groups.grass);
        var aboveGrass = Lib.UTILS.createImageInGroup(0, 389, "aboveGrass", groups.aboveGrass);
        var rock = Lib.UTILS.createImageInGroup(0, 266, "rock", groups.grassObjects);

        var particleGroup = U.GLOB.GROUPS.foregroundPlants;



        //######################################################################
        //create moving trees
        var behindTree1 = new Lib.FxObjects.DynamicPlant({
            texture: "behindTree1",
            x: 100,
            y: 300,
            group: U.GLOB.GROUPS.behindTrees,
            angle: -3,
            minAngle: -0,
            maxAngle: 3,
            guaranteedAngle: 3,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });
        var behindTree2 = new Lib.FxObjects.DynamicPlant({
            texture: "behindTree2",
            x: 390,
            y: 323,
            group: U.GLOB.GROUPS.behindTrees,
            angle: -3,
            minAngle: -0,
            maxAngle: 3,
            guaranteedAngle: 3,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });
        var behindTree3 = new Lib.FxObjects.DynamicPlant({
            texture: "behindTree3",
            x: 610,
            y: 333,
            group: U.GLOB.GROUPS.behindTrees,
            angle: -3,
            minAngle: -0,
            maxAngle: 3,
            guaranteedAngle: 3,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });

        var frontTree1 = new Lib.FxObjects.DynamicPlant({
            texture: "frontTree1",
            x: 317,
            y: 343,
            group: U.GLOB.GROUPS.frontTrees,
            angle: -2,
            minAngle: 0,
            maxAngle: 2,
            guaranteedAngle: 2,
            inverseSpeedMin: 2200,
            inverseSpeedMax: 2500
        });
        var frontTree2 = new Lib.FxObjects.DynamicPlant({
            texture: "frontTree2",
            x: 247,
            y: 333,
            group: U.GLOB.GROUPS.frontTrees,
            angle: -4,
            minAngle: 0,
            maxAngle: 4,
            guaranteedAngle: 4,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });
        var frontTree3 = new Lib.FxObjects.DynamicPlant({
            texture: "frontTree3",
            x: 507,
            y: 333,
            group: U.GLOB.GROUPS.frontTrees,
            angle: -4,
            minAngle: 0,
            maxAngle: 4,
            guaranteedAngle: 4,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });
        var frontTree4 = new Lib.FxObjects.DynamicPlant({
            texture: "frontTree4",
            x: 455,
            y: 340,
            group: U.GLOB.GROUPS.frontTrees,
            angle: -4,
            minAngle: 0,
            maxAngle: 4,
            guaranteedAngle: 4,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });
        var frontTree5 = new Lib.FxObjects.DynamicPlant({
            texture: "frontTree2",
            x: 139,
            y: 320,
            group: U.GLOB.GROUPS.frontTrees,
            angle: -4,
            minAngle: 0,
            maxAngle: 4,
            guaranteedAngle: 4,
            inverseSpeedMin: 1200,
            inverseSpeedMax: 1500
        });

        //######################################################################
        //Tree Fog
        var staticTreesFog = new Lib.FxObjects.Tiler({
            texture: "treeFogGreen",
            speed: 10,
            x: 0,
            y: 250,
            group: U.GLOB.GROUPS.staticTrees,
            blendMode: Phaser.blendModes.NORMAL,
            alpha: 1
        });

        var fogFrontTrees = new Lib.FxObjects.Tiler({
            texture: "treeFogGreen",
            speed: -10,
            x: -200,
            y: 250,
            group: U.GLOB.GROUPS.beforeGrassObjects,
            blendMode: Phaser.blendModes.NORMAL,
            alpha: 1
        });

        //---------------------------

        if (U.Platform.GLOB.quality === "high") {
            var cloudGenerator = new Lib.Generators.LinearTraveler_Gen({
                texture: ["cloud1", "cloud2", "cloud3", "cloud4", "cloud5", "cloud6", "cloud7", "cloud8", "cloud9"],
                genRightRatio: 1,
                genLeftRatio: 0.1,
                group: [U.GLOB.GROUPS.sky, U.GLOB.GROUPS.mountain],
                maxY: 200,
                minY: 100,
                minRandTime: 6, //6
                maxRandTime: 10, //10
                minSpeed: 2, //5
                maxSpeed: 10, //20
                leftX: -550,
                rightX: game.world.width + 550,
                minAlpha: 0.85,
                maxAlpha: 1,
                maxCount: 5,
                minScale: 0.6,
                maxScale: 1,
                startOnScreenCount: 10
            });
        }

        var bigBirdGenerator = new Lib.Generators.LinearTraveler_Gen({
            texture: "bigBird1",
            genRightRatio: 0.2, //0.2
            genLeftRatio: 1,
            group: [U.GLOB.GROUPS.sky],
            maxY: 300,
            minY: 0,
            minRandTime: 2, //6
            maxRandTime: 3, //10
            minSpeed: 5, //5
            maxSpeed: 10, //20
            leftX: -550,
            rightX: game.world.width + 550,
            minAlpha: 0.3,
            maxAlpha: 0.6,
            maxCount: 2,
            minAnimSpeed: 15,
            maxAnimSpeed: 25,
            minScale: 0.05,
            maxScale: 0.25,
            startOnScreenCount: 6
        });

        var smallBirdGenerator = new Lib.Generators.LinearTraveler_Gen({
            texture: "smallBird1",
            genRightRatio: 0.2, //0.2
            genLeftRatio: 1,
            group: [U.GLOB.GROUPS.sky, U.GLOB.GROUPS.mountain, U.GLOB.GROUPS.behindTrees, U.GLOB.GROUPS.staticTrees, U.GLOB.GROUPS.frontTrees],
            maxY: 310,
            minY: 100,
            minRandTime: 2, //6
            maxRandTime: 3, //10
            minSpeed: 15, //5
            maxSpeed: 30, //20
            leftX: -100,
            rightX: game.world.width + 100,
            minAlpha: 0.2,
            maxAlpha: 0.5,
            maxCount: 2,
            minAnimSpeed: 75,
            maxAnimSpeed: 85,
            minScale: 0.05,
            maxScale: 0.1,
            startOnScreenCount: 20,
            forwardFaceDirection: "right",
            minRandTimeChangeY: 2,
            maxRandTimeChangeY: 4,
            minYSpeed: -15,
            maxYSpeed: 25,
            changeYAtStart: true
        });

        var smallFranticBirdGenerator = new Lib.Generators.LinearTraveler_Gen({
            texture: "smallBird1",
            genRightRatio: 0.2, //0.2
            genLeftRatio: 1,
            group: [U.GLOB.GROUPS.sky, U.GLOB.GROUPS.mountain, U.GLOB.GROUPS.behindTrees, U.GLOB.GROUPS.staticTrees, U.GLOB.GROUPS.frontTrees],
            maxY: 310,
            minY: 250,
            minRandTime: 2, //6
            maxRandTime: 3, //10
            minSpeed: 15, //5
            maxSpeed: 30, //20
            leftX: -100,
            rightX: game.world.width + 100,
            minAlpha: 0.6,
            maxAlpha: 0.8,
            maxCount: 3,
            minAnimSpeed: 75,
            maxAnimSpeed: 85,
            minScale: 0.04,
            maxScale: 0.06,
            startOnScreenCount: 20,
            forwardFaceDirection: "right",
            minRandTimeChangeY: 0.5,
            maxRandTimeChangeY: 1,
            minYSpeed: -40,
            maxYSpeed: 40,
            changeYAtStart: true
        });
        var smallArchingBirdGenerator = new Lib.Generators.LinearTraveler_Gen({
            texture: "smallBird1",
            genRightRatio: 0.2, //0.2
            genLeftRatio: 1,
            group: [U.GLOB.GROUPS.sky, U.GLOB.GROUPS.mountain, U.GLOB.GROUPS.behindTrees, U.GLOB.GROUPS.staticTrees, U.GLOB.GROUPS.frontTrees],
            maxY: 310,
            minY: 200,
            minRandTime: 15, //6
            maxRandTime: 30, //10
            minSpeed: 15, //5
            maxSpeed: 30, //20
            leftX: -40,
            rightX: game.world.width + 40,
            minAlpha: 0.6,
            maxAlpha: 0.8,
            maxCount: 1,
            minAnimSpeed: 75,
            maxAnimSpeed: 85,
            minScale: 0.09,
            maxScale: 0.1,
            startOnScreenCount: 0,
            forwardFaceDirection: "right",
            minRandTimeChangeY: 19,
            maxRandTimeChangeY: 24,
            minYSpeed: -15,
            maxYSpeed: -25,
            changeYAtStart: false,
            checkForYLimits: false
        });

        var butterflyGenerator = new Lib.Generators.LinearTraveler_Gen({
            texture: ["butterfly1", "butterflyGreen", "butterflyBlue", "butterflyCyan", "butterflyOrange", "butterflyRed"],
            genRightRatio: 0.5, //0.2
            genLeftRatio: 1,
            group: [U.GLOB.GROUPS.foregroundTrees],
            maxY: 480,
            minY: 330,
            minRandTime: 1, //6
            maxRandTime: 2, //30
            minSpeed: 15, //5
            maxSpeed: 30, //20
            leftX: -150,
            rightX: game.world.width + 150,
            minAlpha: 1,
            maxAlpha: 1,
            maxCount: 10,
            minAnimSpeed: 25,
            maxAnimSpeed: 35,
            minScale: 0.04,
            maxScale: 0.1,
            startOnScreenCount: 40,
            forwardFaceDirection: "right",
            minRandTimeChangeY: 2,
            maxRandTimeChangeY: 4,
            minYSpeed: -30,
            maxYSpeed: 30,
            changeYAtStart: true
        });

        var bigInsectEmitter = new Lib.FxObjects.InsectEmitter({
            texture: ["insect1"],
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.1,
            maxScale: 0.2,
            maxParticles: 10,
            inverseSpeedMin: 30,
            inverseSpeedMax: 60,
            maxParticles: 3,
            distanceMin: 20,
            distanceMax: 40,
            minRotation: -60,
            maxRotation: -15,
            x: 0,
            y: 300,
            width: 720,
            height: 100,
            group: particleGroup
        });
        var smallInsectEmitter = new Lib.FxObjects.InsectEmitter({
            texture: ["insect1"],
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.05,
            maxScale: 0.1,
            maxParticles: 30,
            inverseSpeedMin: 30,
            inverseSpeedMax: 60,
            distanceMin: 20,
            distanceMax: 40,
            minRotation: -60,
            maxRotation: -15,
            x: 0,
            y: 300,
            width: 720,
            height: 100,
            minAlpha: 0.2,
            maxAlpha: 0.6,
            group: particleGroup
        });

        var rightTree = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundTree2",
            group: U.GLOB.GROUPS.foregroundTrees,
            x: 700,
            y: 470, //470
            angle: 0,
            minAngle: -5,
            maxAngle: 5,
            guaranteedAngle: 5,
            inverseSpeedMin: 1000,
            inverseSpeedMax: 2000
        });

        var fPlantSharp2 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantSharp2",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 50,
            y: 620,
            angle: 0,
            guaranteedAngle: 5,
            minAngle: -10,
            maxAngle: 10,
            inverseSpeedMin: 300,
            inverseSpeedMax: 800
        });

        var fPlantSharp1 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantSharp1",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 0,
            y: 530,
            angle: 0,
            guaranteedAngle: 10,
            minAngle: -20,
            maxAngle: 20,
            inverseSpeedMin: 1000,
            inverseSpeedMax: 2000
        });

        var fPlantSharp3 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantSharp2",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 690,
            y: 630,
            angle: 10,
            guaranteedAngle: 5,
            minAngle: -10,
            maxAngle: 10,
            inverseSpeedMin: 300,
            inverseSpeedMax: 800,
            flipH: true
        });

        var fPlantBlur1 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantBlur1",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 180,
            y: 560,
            angle: 0,
            guaranteedAngle: 10,
            minAngle: -20,
            maxAngle: 20,
            inverseSpeedMin: 300,
            inverseSpeedMax: 1000,
            flipH: true
        });

        var fPlantBlur2 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantBlur1",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 610,
            y: 590,
            angle: 0,
            guaranteedAngle: 10,
            minAngle: -20,
            maxAngle: 20,
            inverseSpeedMin: 300,
            inverseSpeedMax: 1000,
            flipH: false
        });
        var fPlantBlur3 = new Lib.FxObjects.DynamicPlant({
            texture: "foregroundPlantBlur1",
            group: U.GLOB.GROUPS.foregroundPlants,
            x: 410,
            y: 580,
            angle: 0,
            guaranteedAngle: 10,
            minAngle: -20,
            maxAngle: 20,
            inverseSpeedMin: 300,
            inverseSpeedMax: 1000,
            flipH: false
        });


        var staticLightRay1 = U.GLOB.GROUPS.foregroundTrees.create(-200, -200, "lightRay1");
        staticLightRay1.tint = 0xfcffd1;
        staticLightRay1.alpha = 0.5;
        staticLightRay1.blendMode = Phaser.blendModes.NORMAL;


        if (U.Platform.GLOB.quality === "high") {

            var lightRay3 = new Lib.FxObjects.Shiner({
                blendMode: Phaser.blendModes.ADD,
                texture: "lightRay1",
                group: U.GLOB.GROUPS.foregroundTrees,
                guaranteedAlpha: 0.1,
                tint: 0xf8ff86,
                x: -160,
                y: -140,
                minRandTime: 10,
                maxRandTime: 15,
                minStayThereDuration: 10,
                maxStayThereDuration: 20,
                targetAlpha: 0.2

            });

            var lightRay2 = new Lib.FxObjects.Shiner({
                blendMode: Phaser.blendModes.NORMAL,
                texture: "lightRay1",
                group: U.GLOB.GROUPS.foregroundTrees,
                guaranteedAlpha: 0.5,
                tint: 0xf8ff86,
                x: -160,
                y: 240,
                minRandTime: 10,
                maxRandTime: 15,
                minStayThereDuration: 2000,
                maxStayThereDuration: 4000

            });

            var lightRay8 = new Lib.FxObjects.Shiner({
                blendMode: Phaser.blendModes.ADD,
                texture: "lightRay1",
                group: U.GLOB.GROUPS.foregroundTrees,
                guaranteedAlpha: 0.1,
                tint: 0xf8ff86,
                x: 100,
                y: -180,
                minRandTime: 10,
                maxRandTime: 15,
                minStayThereDuration: 2000,
                maxStayThereDuration: 4000,
                targetAlpha: 0.3

            });
        }




        var emitterDandelionHead2 = new Lib.FxObjects.BoxEmitter({
            texture: "dandelionHead2",
            blendMode: Phaser.blendModes.ADD,
            minScale: 0.05,
            maxScale: 0.3,
            maxParticles: 5,
            group: particleGroup
        });

        var emitterDandelionHead1 = new Lib.FxObjects.BoxEmitter({
            texture: "dandelionHead1",
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.2,
            maxScale: 0.4,
            maxParticles: 3,
            y: game.world.height,
            minAlpha: 0.8,
            maxAlpha: 1,
            group: particleGroup
        });

        var emitterLargeBlur = new Lib.FxObjects.BoxEmitter({
            texture: ["partBlurHighYellow", "partBlurHigh"],
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.4,
            maxScale: 1,
            maxParticles: 10,
            minScale: 0.4,
            minAlpha: 0.8,
            minRotation: 0,
            maxRotation: 10,
            group: particleGroup
        });

        var emitterSmallSharp = new Lib.FxObjects.BoxEmitter({
            texture: ["partSharp", "partSharpYellow", "partSharpGreen"],
            blendMode: Phaser.blendModes.NORMAL,
            minScale: 0.1,
            maxScale: 0.3,
            maxParticles: 40,
            group: particleGroup
        });

        var emitterLargeSharp = new Lib.FxObjects.BoxEmitter({
            texture: ["partSharpYellow", "partSharpGreen", "partSharpOrange"],
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.4,
            maxScale: 0.8,
            maxParticles: 10,
            inverseSpeedMin: 100,
            inverseSpeedMax: 200,
            minAlpha: 0.2,
            maxAlpha: 0.5,
            group: particleGroup
        });

        var emitterBigSharp = new Lib.FxObjects.BoxEmitter({
            texture: ["bigParticleMediumBlur", "bigParticleHighBlur"],
            blendMode: Phaser.blendModes.SCREEN,
            minScale: 0.1,
            maxScale: 0.3,
            maxParticles: 10,
            inverseSpeedMin: 100,
            inverseSpeedMax: 200,
            minAlpha: 0.2,
            maxAlpha: 0.5,
            group: particleGroup
        });

        this._update = function() {

        }
    }

    obj.Scene = Scene;
    //
    return obj;
}());
